<?
// En-suites - licence GPL
// fonctions utilises par tous les scripts

/*
A faire :
   . vrification des doublons  l'inscription et au login ;

*/

$incipit_len = 21;
/* C'est la longueur de texte en dessous de laquelle */
/* le systme de vote ne peut pas bien fonctionner.  */

$alphabet = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
$maxi = strlen($alphabet) - 1;

// initialisation
if (file_exists("config/config.php"))
   include "config/config.php";

function ecris_config() {
   global $admin_nom, $admin_passe, $inscrits, $phase;
   // crer le fichier
   $fparam = fopen("config/config.php", "w");
   fwrite($fparam, "<?\n");    
   // nom et passe administrateur
   fwrite($fparam, "\$admin_nom = \"$admin_nom\";\n");
   fwrite($fparam, "\$admin_passe = \"$admin_passe\";\n");
   // inscrits
   if (isset($inscrits))
      for ($i = 0; $i < count($inscrits); $i++) {
         fwrite($fparam, '$inscrits[' . $i . ']["nom"] = "' . $inscrits[$i]["nom"] . "\";\n");
         fwrite($fparam, '$inscrits[' . $i . ']["passe"] = "' . $inscrits[$i]["passe"] . "\";\n");
         fwrite($fparam, '$inscrits[' . $i . ']["a_vote"] = "'
               . $inscrits[$i]["a_vote"] . "\";\n");
         fwrite($fparam, '$inscrits[' . $i . ']["points"] = "'
               . $inscrits[$i]["points"]
               . "\";\n");
      }
   // rcit
   if (!isset($phase))
      $phase = 0;
   fwrite($fparam, "\$phase = $phase;\n");

   // balise de fermeture
   fwrite($fparam, "\n?>");
   fclose($fparam);
}

function init_config() {
  global $admin_nom, $admin_passe, $phase;
  $admin_nom = "admin";
  $admin_passe = "admin";
  $phase = 0;
  ecris_config();
}

function login_admin($n, $p) {    
   global $admin_nom, $admin_passe;
   $admin_nom = $n;
   $admin_passe = $p;
   ecris_config();
}

// sessions

if (file_exists("config/sessions.php"))
   include "config/sessions.php";
else {
   $sessions = array();
   $inscrits = array();
}

function ecris_sessions() {
   global $sessions;
   $fichier = fopen("config/sessions.php", "w");
   fwrite($fichier, "<?\n");
   fwrite($fichier, "\$sessions = array(");
   $initial = 1;
   foreach($sessions as $s) {
      if (!$initial)
         fwrite($fichier, ",");
      fwrite($fichier, "\n");
      fwrite($fichier, "\narray("
         . "   \"nom\" => \"" . $s["nom"] . "\",\n"
         . "   \"droits\" => \"" . $s["droits"] . "\",\n"
         . "   \"session\" => \"" . $s["session"] . "\",\n"
         . "   \"debut\" => \"" . $s["debut"] . "\")");
      $initial = 0;
   }
   fwrite($fichier, ");\n?>");
   fclose($fichier);
}

function supprime_session($n) {
   global $sessions;
   foreach ($sessions as $s)
      if ($s["nom"] == $n) {
         $s["session"] = "";
         $s["debut"] = "";
         break;
      }
}

function genere_session() {
  global $alphabet, $maxi;
  mt_srand((double)microtime()*1000000);
  $numero = "";
  for ($i = 0; $i < 20; $i++)
     $numero .= $alphabet[mt_rand(0, $maxi)];
  return $numero;
}

function session2nom($s) {
   // vrifie que le numro $s est valide (date et numro).
   global $sessions;
   foreach ($sessions as $item) {
      if ($item["session"] == $s)
         return $item["nom"];
      }
   return false;
}   

function nom2session($n) {
   // vrifie que le numro $s est valide (date et numro).
   global $sessions;
   foreach ($sessions as $item) {
      if ($item["nom"] == $n)
         return $item;
   }
   return false;
}

function nom2code($n) {
   $resultat = nom2session($n);
   return $resultat["session"];
}

function nom2inscrit($n) {
   global $inscrits;
   foreach($inscrits as $item) {
      if ($item["nom"] == $n)
         return $item;   
   }
   return 0;
}

function nom2indice($n) {
   global $inscrits;
   for ($i = 0; $i < count($inscrits); $i++)
      if ($inscrits[$i]["nom"] == $n)
         return $i;
   return false;
}

function init_session($n, $d) {
   /* inscrit la session dans un fichier ;
    champs : code de session, heure de dbut, nom, passe, droits, a-ecrit, a-vot.
  */
  global $sessions;
  $debut = time();
  $s = genere_session();
  $item = nom2session($n);
  if (!$item) {
     $item = array("nom" => $n, "droits" => $d, "session" => $s, "debut" => $debut);
     array_push($sessions, $item);
  }
  else $item["session"] = $s;
  ecris_sessions();
  return $s;
}

function session2droits($s) {
   global $sessions;
   foreach ($sessions as $item)
      if ($item["session"] == $s) {
         return $item["droits"];
      }
   return 0;
}

function est_inscrit($n, $p) {
   /* vrifie que $n est inscrit et que $p est son mot de passe.
       retourne false si $n n'est pas dans la liste,
       et l'inscrit si $n est dans la liste.
   */
   global $inscrits;
   if (empty($inscrits))
      return false;
   foreach ($inscrits as $i)
      if ($i["nom"] == $n && $i["passe"] == $p) {
         return 1;
      }
   return 0;
}

function verifie($n, $p) {
// attribue  $n un numro de session qui permet de retrouver son profil
   global $inscrits, $admin_nom, $admin_passe;
   if ($n == $admin_nom && $p == $admin_passe) {
      $droits = "2";
      init_session($n, $droits);
      return nom2code($n);
   }
   elseif (est_inscrit($n, $p)) {
      $droits = "1";
      init_session($n, $droits);
      return nom2code($n);
   }
   else return 0;
}

// gestion des inscrits

function adde_ciuem($n, $p) {
   global $inscrits;
   $i = count($inscrits);
   $inscrits[$i]["nom"] = $n;
   $inscrits[$i]["passe"] = $p;
   ecris_config();
}

function dele_ciuem($c) {
   global $inscrits;
   array_splice($inscrits, $c, 1);
   ecris_config();
}

// affichage
function _echo ($s){
   echo htmlentities($s);
}

// rcit : criture et vote

function br2nl($texte) {
   // l'inverse de nl2br. transforme les <br> en sauts de ligne,
   // permettant ainsi le retour d'une suite  l'dition.
   return ereg_replace("<br>", "\n", $texte);
}

function chapitre() {
   global $phase;
   return Floor($phase / 10);
}

function incipit($inscrit, $p) {
   // donne l'incipit du texte crit par $i pour la phase $p.
   global $incipit_len;
   $texte = texte_de($inscrit["nom"], $p);
   return substr($texte, 0, $incipit_len)."#".md5($texte);
}

function incipit2inscrit($inc) {
   global $inscrits, $phase;
   foreach($inscrits as $inscr) {
      $son_incipit = incipit($inscr, $phase - 5);
      if (stripslashes($son_incipit) == stripslashes($inc))
         return $inscr;
   }
   return false;
}

function incipit2indice($md5, $p) {
/* donne l'indice de l'inscrit qui a crit la suite dont le hash est $md5
   pour la phase $p */
   global $inscrits;
   // $incip = htmlentities(stripslashes($incip));
   for ($i = 0; $i < count($inscrits); $i++) {
      $son_incipit = incipit($inscrits[$i], $p);
      if (preg_match("/$md5/",$son_incipit))
         return $i;
   }
   return -1;
}

function texte_de($n, $p) {
   // donne le texte de $n pour la phase $p
   $nom_fichier = "contrib/$n$p.php";
   if (file_exists($nom_fichier)) {
      $fichier = fopen($nom_fichier, "r");
      $t = fread($fichier, filesize($nom_fichier));
      fclose($fichier);
      return $t;
   }
}

function texte($i, $p) {
   // donne le texte pour la phase $p  partir de son hash md5 $i.
   global $inscrits;
   foreach($inscrits as $inscr)
      if (preg_match("/$i/",incipit($inscr, $p))) {
         return texte_de($inscr["nom"], $p);
   }
}

function vote($s, $md5) {
   // l'inscrit de session $s vote pour l'incipit termin pat le hash $md5
   // die("session $s incipit : $incip");
   global $inscrits, $phase;    
   $nom = session2nom($s);
   // refuser un second vote
   if (a_vote($nom))
      return false;
   $elu = incipit2indice($md5, $phase - 5);
   if ($elu > -1) {
      $inscrits[$elu]["points"]++;
      $votant = nom2indice($nom);
      $inscrits[$votant]["a_vote"] = 1;
      ecris_config();
      return true;
   }
   else return false;
}

function a_ecrit($nom) {
   global $phase;
   $fichier = "contrib/$nom$phase.php";
   return file_exists("contrib/$nom$phase.php");
}

function a_vote($nom) {
   global $inscrits;
   foreach($inscrits as $inscr) {
      if ($inscr["nom"] == $nom && $inscr["a_vote"] > 0)
         return 1;
   }
   return false;
}

function ont_ecrit() {
   global $inscrits;
   $resultat = 0;
   if (empty($inscrits))
      return false;
   foreach($inscrits as $i)
      if (a_ecrit($i["nom"])) {
         $resultat++;
         }
   return $resultat;
}

function tous_ont_ecrit() {
   global $inscrits;
   if (empty($inscrits))
      return false;
   return count($inscrits) == ont_ecrit();
}

function ont_vote() {
   global $inscrits;
   if (empty($inscrits))
      return false;
   $result = 0;
   foreach ($inscrits as $i) {
      if ($i["a_vote"] > 0)
         $result++;
   }
   return $result;
}

function tous_ont_vote() {
   global $inscrits;
   if (empty($inscrits))
      return false;
   return count($inscrits) == ont_vote();
}

function bilan_ecriture() {
   global $inscrits;
   $suites = ont_ecrit();
   $manque = count($inscrits) - $suites;
   return "$suites crivains ont envoy leur suite. Il en manque $manque.";
}

function en_regle($nom) {
   global $phase;
   if ($phase % 10 == 0)
      return a_ecrit($nom);
   // pour le vote :
   elseif ($phase > 0)
      return a_vote($nom);
   else return false;
}

function fixe_phase($nv_phase) {
   global $phase, $suffrages, $inscrits, $nouveau_recit, $vainqueur, 
     $source_recit, $proposition_recit, $HTTP_POST_FILES;
   if ($nv_phase == "fin")
      $phase = 0;

   elseif ($nv_phase == "nouveau") {
      $phase = 0;
      if (is_uploaded_file($HTTP_POST_FILES['source_recit']['tmp_name'])){
	$tmp_file=$HTTP_POST_FILES['source_recit']['tmp_name'];
	$proposition_recit= htmlentities(`cat $tmp_file`);
	$nouveau_recit="";
      }
      if (isset ($nouveau_recit) && strlen($nouveau_recit)>50) {
         $fichier = fopen("contrib/recit.txt", "w");
         fwrite($fichier, nl2br(htmlentities(stripslashes($nouveau_recit))));
         fclose($fichier);
	 $phase=10;	
      }      
   }

   elseif ($nv_phase == "vote") {
      // incrmenter la phase;
      $phase += 5;
   }

   elseif ($nv_phase == "ecriture") {
      // dpouillement : points maxi
      $maxi = 0;
      foreach($inscrits as $inscr) {
         if ($inscr["points"] > $maxi)
            $maxi = $inscr["points"];
      }
      // ex aequo ?
      $exaequo = array();
      foreach($inscrits as $inscr)
         if ($inscr["points"] == $maxi)
            array_push($exaequo, $inscr["nom"]);
      // tirage en cas d'galit
      if (count($exaequo) > 1) {
          mt_srand((double)microtime()*1000000);
          $vainqueur = $exaequo[mt_rand(0, count($exaequo))];
      }
      else $vainqueur = $exaequo[0];

      // augmenter le rcit final;
	  // le commentaire <!-- phase p --> sert  sparer les contributions.
      $fichier = fopen("contrib/recit.txt", "a");
      fwrite($fichier, "<br>\n" 
	     . "<!-- chapitre " . chapitre() . " -->"
	     . nl2br(texte_de($vainqueur, $phase - 5)));
      fclose($fichier);
      
      // incrmenter la phase;
      $phase += 5;
      // effacer les votes
      for ($i = 0; $i < count($inscrits); $i++) {
         $inscrits[$i]["a_vote"] = 0;
         $inscrits[$i]["points"] = 0;
      }
   }
   ecris_config();
   return $phase;
}

function quelle_phase() {
   global $phase;
   if ($phase % 10 == 0)
      return "ecriture";
   else return "vote";
}

// texte du rcit, prpar pour l'affichage
function texte_recit() {
  $nom_f_recit = "contrib/recit.txt";
  $f_recit = fopen($nom_f_recit, "r");
  $recit = fread($f_recit, filesize($nom_f_recit));
  // $recit = nl2br($recit);
  fclose($f_recit); 
  return stripslashes($recit); 
}

// tronquer le rcit
function tronque_recit($ch) {
   $nom_recit = "contrib/recit.txt";
   $f_recit = fopen($nom_recit, "r+");
   $recit = fread($f_recit, filesize($nom_recit));
   fclose($f_recit);
   $recit = ereg_replace("<!-- chapitre $ch -->.*$", "", $recit);
   $f_recit = fopen($nom_recit, "w");
   fwrite($f_recit, $recit);
   fclose($f_recit);
}

// passage automatique  la phase suivante.
$quelle_p = quelle_phase();
if ($quelle_p == "ecriture" && tous_ont_ecrit())
   $phase = fixe_phase("vote");
elseif ($quelle_p == "vote" && tous_ont_vote())
   $phase = fixe_phase("ecriture");

function en_tete($session, $reconnexion){
  echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n>";
  echo "<html>\n";
  echo "<head>\n";
  echo "<meta http-equiv='Content-Type' content='text/html;charset=iso-8859-1'>\n";
  echo "  <title>En-suites</title>\n";
  echo "  <style type='text/css'>\n";
  echo "     table {\n";
  echo "        empty-cells : show;\n";
  echo "        background-color : rgb(255,255,221);\n";
  echo "        border : thin solid Black;\n";
  echo "     }\n";
  echo "     body {\n";
  echo "        font-family: sans-serif;\n";
  echo "     }\n";
  echo "     .titre {\n";
  echo "       font-size : 30pt;\n";
  echo "       text-align : center;\n";
  echo "     }\n";
  echo "     .soustitre {\n";
  echo "       font-size : 16pt;\n";
  echo "       text-align : center;\n";
  echo "       font-style : italic;\n";
  echo "     }\n";
  echo "     .important {\n";
  echo "       font-size : 14pt;\n";
  echo "       text-align : center;\n";
  echo "     }\n";
  echo "     .texte {\n";
  echo "       text-align: justify;\n";
  echo "       text-indent: 1cm;\n";
  echo "     }\n";
  echo "  </style>\n";
  echo "</head>\n";
  echo "<body bgcolor='#e6f7Ec'>\n";
  echo "<table width='100%'><tr><td align='left'><a href='./'>dconnexion</a></td>\n";
  if ($reconnexion!="" && $session!="" && $session !="0"){
    echo "<td align='right'><a href=\"$reconnexion?session=$session\">\n";
    echo "reconnexion</a></td></tr>\n";
  } else {
    echo "<td>&nbsp;</td>\n";
  }
  echo "<tr><td colspan='2' align='center'>\n";
  echo "<p class='titre'>En-suites</p>\n";
  echo "<p class='soustitre'>Atelier d'criture en commun appliquant les principes de la\n";
  echo "dmocratie</p>\n";
  echo "</td></tr>\n";
  echo "</table>\n";
}

function pied_page(){
  echo"<table width='100%'><tr align='left'><td>";
  //  gauche
  echo '
    <p>
      <a href="http://validator.w3.org/check/referer"><img border="0"
          src="http://www.w3.org/Icons/valid-html401"
          alt="Valid HTML 4.01!" height="31" width="88"></a>
<a href="http://jigsaw.w3.org/css-validator/">
  <img style="border:0;width:88px;height:31px"
       src="http://jigsaw.w3.org/css-validator/images/vcss" 
       alt="Valid CSS!">
 </a>
    </p>
';  
  echo "</td><td align='right'>";
  //  droite
  echo "<a href='apropos.html'> propos du logiciel en-suites</a> ...";
  echo "</td></tr></table>";
  echo"</body></html>";

}
?>
